; $Id: getkikf_from_efixed_etran.pro,v 1.2 2012/06/26 15:11:33 kneller Exp $

;Calculate the ki,kf values from Qxy, efixed, and etransferred.  Choice whether
;Ei or Ef is fixed.


;####################################################################
function getkikf_from_efixed_etran,Efixed,Etran,Qxy,init=init,final=final

    if n_elements(init) eq 0  then init = 0
    if n_elements(final) eq 0 then final = 0

    if init eq 0 and final eq 0 then final = 1

;print,'init=',init
;print,'final=',final
    ;E = Ei - Ef
    E = Etran
    if final eq 1 then begin
        Ef = Efixed
        Ei = E + Ef
    endif
    if init eq 1 then begin
        Ei = Efixed
        Ef = Ei - E
    endif

;    print,'Ei=',Ei
;    print,'Ef=',Ef
;    print,'E=',Ei-Ef
;    print,'Qxy=',Qxy
    return,getkikf(Ei,Ef,Qxy)


end;getkikf_from_efixed_etran
